<template>

    <svg>
      <path :d = "pathXml"></path>
      <path :d = "axisPath" class="axisLine"></path>
      <circle :cx ="massX" :cy ="massY" r = "10" style="fill: red"></circle>
    </svg>
</template>

<script>
export default {
  name: 'CircleGraph',
  components:{

  },
  props: {
    
  },
  data(){
    return{
      pathXml:"",
      axisPath:"",
      massX :0,
      massY : 0,
      aData: [],
      max:0,
      min:0,
      dif:0
    }
  },
  methods:{
    calculateSpikes:function( step){
      var data = this.aData
      var from = data.length * this.$parent.constPhi
      var arr = []
      var x = 0
      var y = 0
      
        for (let j = from; j > 0; j-= step){
          
          var sum = 0
            for (let i = 0; i < data.length ; i++) {
                    x = Math.sin(i/j)*parseFloat(data[i]);
                    sum += (x*100)
              }      
              arr.push({"period":j,"mass" :  sum/data.length})
        }
        
        return arr;

    },
    calculatePath : function (data,period) {
      
      
      this.aData = data
      var path = 'M 0 0 '
      // vertical and horizontal centers
      const vc = this.$el.clientWidth/2
      const hc =  this.$el.clientHeight/2

      

      this.max = parseFloat(data[0])
      this.min = parseFloat(data[0])
      

       for (let i = 0; i < data.length; i++) {
         var val = parseFloat(data[i]);
        if(val< this.min) this.min = val;
        if(val> this.max) this.max = val;
      }

      //Ratio adapt the size of the graph
      const u =  vc/this.max ;
      //variable to calculate the 'center of mas'
      var sum = 0
       var balance = (this.min<0)? -this.min:this.min;
      for (let i = 0; i < data.length; i++) {
        const element = parseFloat(data[i]);
        
        var angle = i/period;
        var dist =(element-balance)*u
        var x = vc+(Math.sin(angle)*dist)
        var y = hc+(Math.cos(angle)*dist)
    
    
        
        sum += x
        path += ` L ${x} ${y}`
      }      
      this.massX = sum /data.length
     
     
     
      
      return path
    },
    reloadPeriod : function (period) {
      
      var data = this.aData;
      
      var path = 'M 0 0 '
      // vertical and horizontal centers
      const vc = this.$el.clientWidth/2
      const hc =  this.$el.clientHeight/2
      //Ratio adapt the size of the graph
      const u =  vc/this.max ;
      //variable to calculate the 'center of mas'
      var sum = 0
      var balance = (this.min<0)? -this.min:this.min;
      for (let i = 0; i < data.length; i++) {
        const element = parseFloat(data[i]);
        var angle = i/period;
        var dist =(element-balance)*u
        var x = vc+(Math.sin(angle)*dist)
        var y = hc+(Math.cos(angle)*dist)
    
        
        sum += x
        path += ` L ${x} ${y}`
      }      
      this.massX = sum /data.length
      console.log(this.max,this.min);
      
      return path;
    },
    drawAxis:function(){      
      const width = this.$el.clientWidth
      const height = this.$el.clientHeight
      return `M ${width/2} 0 L ${width/2} ${height} M 0 ${height/2} L ${width} ${height/2}`
    }


  },
  // on create
  mounted(){
    this.axisPath = this.drawAxis()
   this.massY = this.$el.clientHeight/2
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
path{
    stroke: #2b2854;
    fill: transparent;

}
.axisLine{
  stroke: 4px black transparent
}
svg{
 position: absolute;
  top: 0;
  left: 0;
 width: 100%;
 height: 100%;
  background-color: #f4f4fb
}

</style>
